/* must be same in include/asm/page_offset.h and src/sys.lds! */
#define MEM_BASE (0x70000000)
//#define MEM_BASE (0x80000000)
#define MAX_CPU 16

/* #define DEBUG */
#ifdef DEBUG
#define dfprintf(fmt, arg...)	fprintf(stderr, fmt, ##arg)
#else
#define dfprintf(fmt, arg...)
#endif

/* reserved memory for APICs */
#define IO_APIC_BASE    0xFEC00000
#define IO_APIC_SIZE    PAGE_SIZE
#define LOCAL_APIC_BASE 0xFEE00000
#define LOCAL_APIC_SIZE PAGE_SIZE

/* msb/lsb of init vector */
#define INIT_LOW	0x467
#define INIT_HIGH	0x469

extern char *progname;
extern int opt_p;
extern int opt_c;
extern int opt_mp;
extern int pids[MAX_CPU];

extern void umcore_init(int);
extern void umcore_CPU_init(int, int);
extern void umcore_shutdown(int);

extern void ummem_CPU_init(void);
extern void ummem_init(void);
extern void ummem_shutdown(void);

extern void umrtc_init(void);
extern void umrtc_CPU_init(void);
extern void umrtc_shutdown(void);

extern void umkeyboard_init(void);
extern void umkeyboard_shutdown(void);

extern void umvideo_CPU_init(void);
extern void umvideo_init(void);
extern void umvideo_shutdown(void);

extern void umfloppy_init(void);
extern void umfloppy_shutdown(void);

extern void umide_init(void);
extern void umide_shutdown(void);

extern void umnet_init(void);
extern void umnet_shutdown(void);

extern void umsmp_init(int);

extern void umapic_CPU_init(int, int);
extern void umapic_init(int);
extern void umapic_shutdown(int);
extern void umapic_fork(int);

extern char **lilo_conf_read(void);
extern void (*do_load(char **argv))(int nr);
extern void (*do_wait(int))(int nr);
