/*
 * $Id: umcore.c,v 1.3 2003/02/27 18:56:46 dunlapg Exp $
 */

#include <assert.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/mman.h>

#include "lotol_fdesc.h"


void
umcore_CPU_init(int cpu, int ncpus)
{
	int i;
	int ret;

	for (i = 0; i < ncpus; i++) {
		if (i == cpu) {
			ret = (int) mmap((char *) VA_CPU, SZ_CPU,
					PROT_READ | PROT_WRITE,
					MAP_FIXED | MAP_SHARED,
					FD_CPU(cpu), 0);
			assert(ret == VA_CPU);

		} else {
			ret = close(FD_CPU(i));
			assert(0 <= ret);
		}
	}
}

void
umcore_init(int ncpus)
{
	int cpu;
	int fd;
	int ret;


	assert(1 <= ncpus && ncpus <= 32);

	for (cpu = 0; cpu < ncpus; cpu++) {
		static char page[SZ_CPU];
		char tmpfile[256];

		// added by STK to support ramfs
		sprintf(tmpfile, "/tmp/umlinux/cpu%d", getpid());
		fd = open(tmpfile, O_EXCL | O_CREAT | O_RDWR, 0600);
		if(fd <= 0) {
		  sprintf(tmpfile, "/tmp/cpu%d", getpid());	    
		  fd = open(tmpfile, O_EXCL | O_CREAT | O_RDWR, 0600);
		}	    
		assert(0 <= fd && fd < FD_LOTOL_MIN);

#if 0
		ret = unlink(tmpfile);
		assert(0 <= ret);
#endif
		ret = write(fd, page, sizeof(page));
		assert(ret == sizeof(page));

		ret = dup2(fd, FD_CPU(cpu));
		assert(ret == FD_CPU(cpu));

		ret = close(fd);
		assert(0 <= ret);
	}
}

void
umcore_shutdown(int ncpus)
{
	int cpu;
	int ret;

	assert(1 <= ncpus && ncpus <= 32);

	for (cpu = 0; cpu < ncpus; cpu++) {
		ret = close(FD_CPU(cpu));
		assert(0 <= ret);
	}
}
