#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <asm/unistd.h>

#include <revirt/rlog.h>
#include <revirt/ztrace.h>
#include <revirt/syscalls.h>

/* FIXME -- just for now */
#define ZTRACE_GETSTATE 8

int main(int argc, char * argv[]) {
	struct ztrace_state_struct zt_state;
	int pid, i;
	zt_state.regs.edx = 0xcafe0000;
	if(argc < 2) {
		fprintf(stderr, "Usage: %s pid\n", argv[0]);
		exit(1);
	}
	pid=atoi(argv[1]);
	if(ztrace(ZTRACE_GETSTATE, pid,0,&zt_state)) {
		perror("getstate");
	}
	print_state(&zt_state);
#if 0
	printf( "eax:0x%8x\teip:0x%8x\n" \
		"ebx:0x%8x\tesp:0x%8x\n" \
		"ecx:0x%8x\tebp:0x%8x\n" \
		"edx:0x%8x\txds:0x%8x\n" \
		"esi:0x%8x\txes:0x%8x\n" \
		"edi:0x%8x\txcs:0x%8x\n" \
		"efl:0x%8x\txss:0x%8x\n" \
		"replay_flags: 0x%x\tzt_flags: 0x%x\n"  \
		"zt_rununtil: eip:0x%x\twchan:0x%x\tflags:0x%08x\n",
		zt_state.regs.eax, zt_state.regs.eip,
		zt_state.regs.ebx, zt_state.regs.esp,
		zt_state.regs.ecx, zt_state.regs.ebp,
		zt_state.regs.edx, zt_state.regs.xds,
		zt_state.regs.esi, zt_state.regs.xes,
		zt_state.regs.edi, zt_state.regs.xcs,
		zt_state.regs.eflags, zt_state.regs.xss,
		zt_state.replay_flags, zt_state.zt_flags,
		zt_state.zt_rununtil.eip,
		zt_state.zt_rununtil.wchan,
		zt_state.zt_rununtil.flags);
	printf("cr2:0x%8x\ttrap_no:0x%8x\terror_code:0x%8x\n",
		zt_state.cr2, zt_state.trap_no, zt_state.error_code);
	for(i=0; i<8; i++) {
		printf("debugreg[%d]:0x%x\n", i, zt_state.debugreg[i]);
	}
	printf("code: ");
	for(i=0; i<16; i++) {
		printf("%x ", (int) zt_state.code[i]);
	}
	printf("\n");
	printf("b:0x%16llx\ti:0x%8x\tpf:0x%8x\n",
		zt_state.ctr.hw_branch,
		zt_state.ctr.hw_intr,
		zt_state.ctr.ex_pf);
#endif
	return(0);
}
