#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <asm/unistd.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "readlog.h"
#include "misc.h"
#include <revirt/rlog.h>
#include <string.h>


static void *log;
static void *schedlog,*forklog;
static unsigned int logsize, seek;

#define BUFSIZE (4096*2)

static int fd;
char buf[BUFSIZE];

/* gcc may align things.. kernel prints packed */
#define DATAOF(x) ((void*) (((char*) (x))+sizeof(struct rlog_header)))

void zr_open_log(char *fn) {
	struct stat sbuf;
	fprintf(stderr, "about to open\n");
	try((fd= open(fn,O_RDONLY))>0);
#if 0
	fprintf(stderr, "about to fstat\n");
	try(fstat(fd,&sbuf)==0); 
//	try(syscall(__NR_fstat, fd, &sbuf)==0); 
	logsize= sbuf.st_size;
	fprintf(stderr, "about to mmap\n");
	try((log= mmap(0,logsize,PROT_READ,MAP_PRIVATE,fd,0))!=MAP_FAILED);
	fprintf(stderr, "about to close\n");
	try(close(fd)==0);
	schedlog= log;
	forklog= log;
#endif
	fprintf(stderr, "about to return\n");
}

void zr_release_log(void) {
	close(fd);
}

static void * zr_next_entry(void) {
	struct rlog_header * rh = (__typeof(rh)) buf;
	char * data = buf + sizeof(*rh);
	int len;

	len=read(fd, rh, sizeof(*rh));
//	printf("Read log: type %d, len %d to addr 0x%x\n", rh->type, rh->len, rh);
	try(len == sizeof(*rh));
	try(rh->len +sizeof(*rh) <= BUFSIZE);
	len = read(fd, data, rh->len);
//	printf("Read log: %d bytes read to address 0x%x\n", len, data);
	try(len = rh->len);
	return buf;
}

struct rlog_header * zr_next_schedrec(void) {
	struct rlog_header * sr;
	sr=buf;
	do {
		sr = zr_next_entry();
	} while(!IS_SCHED(sr->type));
	try(sr);
	return sr;
}

#if 0
void zr_release_log(void) {
	try(munmap(log,logsize)==0);
}

static void *zr_next_entry(void *e) {
	struct rlog_header *rh;
	rh= e;
	e+= rh->len + sizeof(*rh);
	if (e-log>logsize)
		return 0;
	else
		return e;
}

struct rlog_header * zr_next_schedrec(void) {
	struct rlog_header *sr;
	sr= schedlog;
	while(sr && (!IS_SCHED(sr->type)) )
		sr=zr_next_entry(sr);
	try(sr);
	schedlog= zr_next_entry(sr);
	return sr;
}
#endif
