#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <asm/unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <fcntl.h>

#include <revirt/rlog.h>
#include <revirt/syscalls.h>

int count(char *buf,int end){
	char *z;
	int c;

	c=0;
	for(z=buf;z-buf<end;) {
		while(*z) z++;
		z++;
		c++;
	}

	return c;
}

void mk_argv(char **argv,int argc,char *buf) {
	int i;
	for(i=0;i<argc;i++) {
		argv[i]= buf;
		buf+= strlen(buf)+1;
	}
	argv[i]= 0;
}

void rexecve(char *iname,char **argv,char **env,char *log) {
	int ret;
	asm volatile("int $0x80" 
			: "=a" (ret)
			: "a" (__NR_rexecve), "b" (iname),
			  "c" (argv), "d" (env), "S" (log)
			 );

	//printf("rexecve returns. errcode= %d\n",ret);
	//printf("%s\n",strerror(-ret));
}

int rfork(int pid) {
	int ret;
	asm volatile("int $0x80" 
			: "=a" (ret)
			: "a" (__NR_rfork), "b" (pid)); 
	//printf("rfork returns. errcode= %d\n",ret);
	//printf("%s\n",strerror(-ret));
	return ret;
}


void replay(char *logname) {
	int fd, pid;
	char *b;
	char **argv, **env, **pp;
	int argc,envc;
	char *iname;
	struct rlog_header rh;
	struct rlog_entry_scall_lexecve *se;
	int dsize, status;
	
	
	fd= open(logname,O_RDONLY);
	if (fd<0) {
		perror("open");
		goto nofile;
	}

	while(1) {
		int l;
		l=read(fd, &rh, sizeof(rh));
		if(l<0) {
			perror("Reading file");
			exit(1);
		}
		if(l==0) {
			fprintf(stderr, "No lexecve entry!\n");
			exit(1);
		}
		if(rh.type == ENTRY_EXECPARM)
			break;
		lseek(fd, rh.len, SEEK_CUR);
	}

	dsize= rh.len;
	b = alloca(dsize);
	read(fd, b, dsize);
	se = (struct rlog_entry_scall_lexecve *) b;
	dsize -= sizeof(se);

//	iname= b + se->fname_index;
	iname = b + sizeof(*se);
#if 0
	while(*argbuf) argbuf++;
	argbuf++;
#endif
	argc= count(b+se->argv_index,se->env_index - se->argv_index);
	envc= count(b+se->env_index,dsize - se->env_index);

	argv= alloca((argc+1)*sizeof(char*));
	env= alloca((envc+1)*sizeof(char*));

	mk_argv(argv,argc,b+se->argv_index);
	mk_argv(env,envc,b+se->env_index);

	close(fd);

#if 0
	printf("iname: %s\n--ARGV--\n", iname);
	for(pp=argv; *pp; pp++) {
		printf("%s\n", *pp);
	}
	printf("--ENV--\n");
	for(pp=env; *pp; pp++) {
		printf("%s\n", *pp);
	}
#endif

	if((pid=rfork(se->pid))<0) {
		perror("rfork");
		exit(1);
	} else if(pid == 0) {
		rexecve(iname,argv,env,logname);
	}
	printf("pid: %d\n", pid);
	waitpid(-1,&status,0); 
	printf("Child returned %d.\n", status);
	if(WIFEXITED(status)) {
		printf(" child exited normally, code=%d\n",
				WEXITSTATUS(status));
	}


	return ;

nofile:
	printf("nofile\n");
	return ;
}

int main(int argc,char **argv) {
	printf("rexec: %d\n",getpid());
	
	if(argc != 2) {
		fprintf(stderr, "Usage: %s logfile\n", argv[0]);
	}	

	replay(argv[1]);

	return 0;
}

