#!/bin/bash


if [ -z "$UMLHOME" ] ; then
        UMLHOME="/home/umlinux/umlinux-test" ;
fi

if [ -z "$LOGBASE" ] ; then
        LOGBASE="/log/uml" ;
fi

EXTYPE=log
if [ "$EXNUM" ] ; then
        EXFILE=$EXTYPE.$EXNUM ;
        LOGFILE=$LOGBASE.$EXNUM ;
else
        EXFILE=$EXTYPE ;
        LOGFILE=$LOGBASE ;
fi

if [ -z "$VMIP" ] ; then
	VMIP='141.213.8.61' ;
fi

NETCMD="./net"

NET_RUN="$NETCMD -l $VMIP 0"

FAKEFRONT="./UMLfront"

VM_LOG="/home/replay/linux/zR/log ../lilo ../vmlinux-2.2 root=/dev/hda1 $VMARGS"

# --- Code starts here!!! ---
echo Starting log run

echo  "- Stopping kupdated..."
kill -STOP `pidof kupdated`
echo " ...and syncing disks"
sync

echo  "- Starting rlogd, sending to $LOGFILE"
/home/replay/linux/rlogd/rlogd $LOGFILE &

echo  - Starting UMLfront, sleeping for user to click 'node1'
cd $UMLHOME
$FAKEFRONT &
sleep 5

echo  - Starting net process $VMIP
cd $UMLHOME/umnp
$NET_RUN &

echo  - Starting lilo
cd $UMLHOME/node1
$VM_LOG >& $UMLHOME/logs/$EXFILE.lilo &

while [ -z "$VMPID" ] ; do
	VMPID=`pidof lilo` ;
done

RLOGDPID=`pidof rlogd`
FAKEPID=`pidof UMLfront`
NETPID=`pidof net`
LOGPID=`pidof log`

echo rlogd $RLOGDPID
echo fakepid $FAKEPID
echo netpid $NETPID
echo logpid $LOGPID
echo vmpid $VMPID

echo  - Waiting for logging pid $LOGPID to shut down

wait $LOGPID

echo  "- UMLinux finished. Grepping /var/log/messages for markers."

grep "ztrace_marker: pid $VMPID" /var/log/messages > $UMLHOME/logs/$EXFILE.marker

echo  - Shutting down net process...
kill $NETPID
wait $NETPID
echo  - Net process shut down.

echo  - Shutting down UMLfront...
kill $FAKEPID
wait $FAKEPID

echo  "- Shutting down rlogd process..."
kill -INT $RLOGDPID
wait $LOGDPID
echo  "- rlogd shut down."

echo "- Starting kupdated again..."
kill -CONT `pidof kupdated`
echo " ...and syncing disks"
sync

echo Log run finished.
