#!/bin/bash

if [ -z "$UMLHOME" ] ; then
	UMLHOME="/home/umlinux/umlinux-test" ;
fi

EXTYPE=run
if [ "$EXNUM" ] ; then
        EXFILE=$EXTYPE.$EXNUM ;
else
        EXFILE=$EXTYPE ;
fi

NETCMD="./net"

if [ -z "$VMIP" ] ; then
        VMIP='141.213.8.61' ;
fi

NET_RUN="$NETCMD -l $VMIP 0"

UMLFRONT="./UMLfront"

VM_RUN="../lilo ../vmlinux-2.2 root=/dev/hda1 $VMARGS"

# --- Code starts here!!! ---
echo Starting normal run

echo  "- Stopping kupdated..."
kill -STOP `pidof kupdated`
echo " ...and syncing disks"
sync

echo  - Starting UMLFront, sleeping while user clicks 'node1'
cd $UMLHOME
$UMLFRONT &
sleep 5

echo  - Starting net process
cd $UMLHOME/umnp
$NET_RUN &

echo  - Starting lilo
cd $UMLHOME/node1
$VM_RUN >& $UMLHOME/logs/run.lilo &

while [ -z "$VMPID" ] ; do
	VMPID=`pidof lilo` ;done

FAKEPID=`pidof UMLfront`
NETPID=`/sbin/pidof net`

echo vmpid $VMPID
echo fakepid $FAKEPID
echo netpid $NETPID

echo  - Waiting for UMLinux pid $VMPID to shut down

wait $VMPID

echo  "- UMLinux finished. Grepping /var/log/messages for markers."

grep "ztrace_marker: pid $VMPID" /var/log/messages > $UMLHOME/logs/$EXFILE.marker

echo  - Shutting down net process...
kill $NETPID
wait $NETPID
echo  - Net process shut down.

echo  - Shutting down UMLfront
kill $FAKEPID
wait $FAKEPID
echo  - UMLfront shut down.

echo "- Starting kupdated again..."
kill -CONT `pidof kupdated`
echo " ...and syncing disks"
sync

echo Normal run finished.
