#!/bin/bash


if [ -z "$UMLHOME" ] ; then
        UMLHOME="/home/umlinux/uml2.4.18" ;
fi

if [ -z "$LOGBASE" ] ; then
        LOGBASE="/log/uml" ;
fi

EXTYPE=log
if [ "$EXNUM" ] ; then
        EXFILE=$EXTYPE.$EXNUM ;
        LOGFILE=$LOGBASE.$EXNUM ;
else
        EXFILE=$EXTYPE ;
        LOGFILE=$LOGBASE ;
fi

if [ -z "$VMIP" ] ; then
	VMIP='141.213.8.111' ;
fi

#NETCMD="./start_networking"

#NET_RUN="$NETCMD $VMIP"

FAKEFRONT="../bin/fake_umlfront"

VM_LOG="/home/replay/linux/zR/log ../lilo"

# --- Code starts here!!! ---
echo Starting logged X run

echo  "- Stopping kupdated..."
kill -STOP `pidof kupdated`
echo " ...and syncing disks"
sync

echo  "- Starting rlogd, sending to $LOGFILE"
/home/replay/linux/rlogd/rlogd $LOGFILE &

echo "- Starting X server"
startx &

while [ -z "$XSLEEPPID" ] ; do
	XSLEEPPID=`pidof sleep` ;
done

echo  - Starting fakeumlfront, piping to $EXFILE.log
cd $UMLHOME/node0
$FAKEFRONT $VM_LOG > $UMLHOME/logs/$EXFILE.con &

while [ -z "$VMPID" ] ; do
	VMPID=`pidof lilo` ;
done

echo  - Setting up net forwarding $VMIP
cd $UMLHOME
sleep 15
$NET_RUN &

RLOGDPID=`pidof rlogd`
FAKEPID=`pidof fake_umlfront`
LOGPID=`pidof log`

echo rlogd $RLOGDPID
echo fakepid $FAKEPID
echo logpid $LOGPID
echo vmpid $VMPID
echo xsleeppid $XSLEEPPID

echo  - Waiting for fake_umlfront  to shut down
wait $FAKEPID

echo - Killing sleep pid
kill $XSLEEPPID

echo  "- UMLinux finished. Grepping /var/log/messages for markers."

grep "ztrace_marker: pid $VMPID" /var/log/messages > $UMLHOME/logs/$EXFILE.marker

echo  "- Shutting down rlogd process..."
kill -INT $RLOGDPID
wait $LOGDPID
echo  "- rlogd shut down."

echo "- Starting kupdated again..."
kill -CONT `pidof kupdated`
echo " ...and syncing disks"
sync

echo Logged X run finished.
