#!/bin/bash
. config

EXTYPE=replay
if [ "$EXNUM" ] ; then
	EXFILE=$EXTYPE.$EXNUM ;
	LOGFILE=$LOGBASE.$EXNUM ;
else
	EXFILE=$EXTYPE ;
	LOGFILE=$LOGBASE ;
fi

#
# --- Code starts here!!! ---
#
echo Starting X replay run

echo  "- Stopping kupdated..."
kill -STOP `pidof kupdated`
echo " ...and syncing disks"
sync

echo  "- Starting rexec, piping to $EXFILE.log"
cd $UMLHOME/$NODE
$VM_REP $LOGFILE > $UMLHOME/logs/$EXFILE.con &

while [ -z  "$VMPID" ] ; do
	VMPID=`pidof lilo` ;
done

echo  "- Starting zr $VMPID $LOGFILE"
$VM_ZR $VMPID $LOGFILE 16 > $UMLHOME/logs/$EXFILE.zr &

while [ -z "$ZRPID" ] ; do
	ZRPID=`pidof zr` ;
done

while [ -z "$REXECPID" ] ; do
	REXECPID=`pidof rexec` ;
done

echo - Starting network forwarding
cd $UMLHOME
sleep 10

./start_networking $VMIP
UMLinux/set_iptables $VMIP
XReplay/ipt_user > $UMLHOME/logs/$EXFILE.forward &

while [ -z "$NETPID" ] ; do
	NETPID=`pidof ipt_user`;
done

echo zr $ZRPID
echo rexec $REXECPID
echo fakepid $FAKEPID
echo vmpid $VMPID

# Can't wait for vmpid because it's "Not a child of this shell"
echo  - Waiting for rexecpid  to shut down
wait $REXECPID

echo  "- UMLinux finished. Grepping /var/log/messages for markers."

grep "ztrace_marker: pid $VMPID" /var/log/messages > $UMLHOME/logs/$EXFILE.marker

echo - Waiting for zr to shut down
wait $ZRPID

kill $NETPID
UMLinux/clear_iptables

echo "- Starting kupdated again..."
kill -CONT `pidof kupdated`
echo " ...and syncing disks"
sync

echo Removing old map files in /tmp/umlinux/\*$VMPID
rm -rf /tmp/umlinux/*$VMPID

echo Replay run finished.
